/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-2000, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/choose.e,v 4.7 2000/01/15 22:24:35 william Exp $
 */

#ifndef _CHOOSE_E_
#define _CHOOSE_E_

#ifdef _INCLUDE_FROM_CHOOSE_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_CHOOSE_C_*/

extern int	GetWorkingDirectory ARGS_DECL((char *buf, int buf_sz));
extern int	SetWorkingDirectory ARGS_DECL((char *dir));
extern void	CleanUpCheckArray ARGS_DECL((struct CheckArrayRec *));
extern int	CopyCheckArray ARGS_DECL((struct CheckArrayRec *pTo,
		                          struct CheckArrayRec *pFrom));
extern void	NamesSetTitle ARGS_DECL((char*));
extern void	ResetNamesInfo ARGS_DECL((void));
extern void	InitNamesInfo ARGS_DECL((void));
extern void	CleanUpNamesInfo ARGS_DECL((void));
extern void	NamesAddButton ARGS_DECL((char*, int));

extern void	NamesSetDefaultBtnId ARGS_DECL((int def_btn_id,
		                                int double_click_btn_id));
extern void	NamesSetStyle ARGS_DECL((int edit_style, int loop_once));
extern void	NamesSetEntries ARGS_DECL((DspList*, char**, int num_entries,
		                           struct CheckArrayRec*,
		                           int dont_free_entries,
		                           int marked_index, int leading));
extern void	NamesSetCallback ARGS_DECL((GetEntriesFunc *pf_before_loop,
		                            AfterLoopFunc *pf_after_loop,
		                            CheckUpdateFunc *pf_check_update));
extern void	NamesSetDir ARGS_DECL((char*));
extern int	Names ARGS_DECL((char *win_name, int *pn_selected_index,
		                 char *selected_str, int str_sz, void*));

#ifdef _INCLUDE_FROM_CHOOSE_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_CHOOSE_C_*/

#endif /*_CHOOSE_E_*/
