/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-2000, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/eps.e,v 4.8 2000/05/20 22:36:13 william Exp $
 */

#ifndef _EPS_E_
#define _EPS_E_

extern float	defaultEPSScaling;
extern char	defaultEPSScalingStr[];

extern int	autoEPSPreviewBitmap;

#ifdef _INCLUDE_FROM_EPS_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_EPS_C_*/

extern void	InitEPS ARGS_DECL((void));
extern void	CleanUpEPS ARGS_DECL((void));
extern int	MyReadEPSFile ARGS_DECL((char *FileName, int *ImageW,
		                         int *ImageH, Pixmap *, XImage **,
		                         int *NumLines, char ***EPSFLines,
		                         int *EPSFLevel, float *llx,
		                         float *lly, float *urx, float *ury,
		                         char *Date));
extern void	DumpEPSObj ARGS_DECL((FILE *, struct ObjRec *));
extern void	SetEPSObjCTM ARGS_DECL((struct ObjRec *, struct BBRec *));
extern struct ObjRec	* CreateEPSObj ARGS_DECL((char *FileName, int ImageW,
			                          int ImageH, Pixmap,
			                          XImage *, int NumLines,
			                          char **Lines, int EPSFLevel,
		                                  float *llx, float *lly,
			                          float *urx, float *ury,
			                          char *Date));
extern void	UpdateEPS ARGS_DECL((void));

#ifdef _INCLUDE_FROM_EPS_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_EPS_C_*/

#endif /*_EPS_E_*/
