/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-2000, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/move.e,v 4.7 2000/01/15 22:24:53 william Exp $
 */

#ifndef _MOVE_E_
#define _MOVE_E_

extern int	oneMotionTimeout;
extern int	minMoveInterval;

#ifdef _INCLUDE_FROM_MOVE_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_MOVE_C_*/

extern void	MoveObj ARGS_DECL((struct ObjRec *, int Dx, int Dy));
extern void	MoveAllSelObjects ARGS_DECL((int Dx, int Dy));
extern int	EndPtInSelected ARGS_DECL((int XOff, int YOff));
extern void	MoveAllSel ARGS_DECL((int Dx, int Dy));
extern void	MoveAnObj ARGS_DECL((struct ObjRec *ObjPtr,
		                     struct ObjRec *TopOwner, int Dx, int Dy));
extern void	MoveAnAttr ARGS_DECL((struct AttrRec *AttrPtr,
		                      struct ObjRec *AttrOwnerObj,
		                      int Dx, int Dy));
extern void	MoveSel ARGS_DECL((int Dx, int Dy, struct ObjRec *,
		                   XButtonEvent *));
extern void	MoveAllSelVs ARGS_DECL((int Dx, int Dy));
extern void	MoveSelVs ARGS_DECL((int OrigX, int OrigY));

#ifdef _INCLUDE_FROM_MOVE_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_MOVE_C_*/

#endif /*_MOVE_E_*/
