/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-2000, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/obj.e,v 4.9 2000/01/15 22:24:55 william Exp $
 */

#ifndef _OBJ_E_
#define _OBJ_E_

extern struct ObjRec	* topObj, * botObj;

#ifdef _INCLUDE_FROM_OBJ_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_OBJ_C_*/

extern void	AddObj ARGS_DECL((struct ObjRec *Prev, struct ObjRec *Next,
		                  struct ObjRec *));
extern void	UnlinkObj ARGS_DECL((struct ObjRec *));
extern void	ReplaceObj ARGS_DECL((struct ObjRec *old_obj,
		                      struct ObjRec *new_obj));
extern void	FreeObj ARGS_DECL((struct ObjRec *));
extern void	DelObj ARGS_DECL((struct ObjRec *));
extern void	DelAllObj ARGS_DECL((void));
extern void	AdjObjOBBox ARGS_DECL((struct ObjRec *));
extern void	AdjObjBBox ARGS_DECL((struct ObjRec *));
extern void	RecursivelyAdjObjBBox ARGS_DECL((struct ObjRec *sub_obj,
		                                 struct ObjRec *owner_obj,
		                                 struct ObjRec *top_owner));
extern void	AdjObjCache ARGS_DECL((struct ObjRec *));
extern void	AdjCaches ARGS_DECL((void));
extern void	AdjObjSplineVs ARGS_DECL((struct ObjRec *));
extern void	AdjSplineVs ARGS_DECL((void));
extern void	ClearObjCachesInAllPages ARGS_DECL((void));
extern void	MoveRotatedObjCache ARGS_DECL((struct ObjRec *, int, int));
extern void	AdjObjHotSpot ARGS_DECL((void));
extern void	AdjHotSpots ARGS_DECL((void));
extern int	IsTopLevelObject ARGS_DECL((struct ObjRec *));

extern struct ObjRec	*GetTopOwner ARGS_DECL((struct ObjRec *));

#ifdef _INCLUDE_FROM_OBJ_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_OBJ_C_*/

#endif /*_OBJ_E_*/
