/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-2000, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/pin.e,v 4.6 2000/01/15 22:24:58 william Exp $
 */

#ifndef _PIN_E_
#define _PIN_E_

extern struct ObjRec *gpStartPin, *gpEndPin;

#ifdef _INCLUDE_FROM_PIN_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_PIN_C_*/

extern int	FindExtraPoly ARGS_DECL((struct SelRec *pTopSel,
		                   struct SelRec *pBotSel,
		                   struct SelRec **ppTopSel,
		                   struct SelRec **ppBotSel, int *pnCount,
		                   struct BBRec *pBBox));
extern void	HighLightAPin ARGS_DECL((int nForward));
extern void	HandlePinHighlights ARGS_DECL((int MouseX, int MouseY));
extern void	ConnectPins ARGS_DECL((void));
extern void	FreeConn ARGS_DECL((struct ConnRec *pConn));
extern void	DelConnFromPoly ARGS_DECL((struct ConnRec *pConn));
extern void	DelConnFromPin ARGS_DECL((struct ConnRec *pConn));
extern void	CleanUpPins ARGS_DECL((void));
extern int	InitPins ARGS_DECL((void));

#ifdef _INCLUDE_FROM_PIN_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_PIN_C_*/

#endif /*_PIN_E_*/
