/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-2000, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/ps.e,v 4.7 2000/01/15 22:25:02 william Exp $
 */

#ifndef _PS_E_
#define _PS_E_

extern int	preDumpSetup;
extern int	needsTgifOrigCTM;
extern int	psUseShortHand;

extern char	**gPsCmd;

#ifdef _INCLUDE_FROM_PS_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_PS_C_*/

extern void	PSUsePSAdobe ARGS_DECL((void));
extern void	PSUseMinRadius ARGS_DECL((void));
extern void	PSUseEllipse ARGS_DECL((void));
extern void	PSUseArrow ARGS_DECL((void));
extern void	PSUseArc ARGS_DECL((void));
extern void	PSUseBWPattern ARGS_DECL((void));
extern void	PSUseColorImage ARGS_DECL((void));
extern void	PSUseColorPattern ARGS_DECL((void));
extern void	PSUseCenterText ARGS_DECL((void));
extern void	PSUseRightText ARGS_DECL((void));
extern void	PSUseMiniLines ARGS_DECL((void));
extern void	PSUseReencode ARGS_DECL((char *FontName));
extern void	PSDontUseShortHand ARGS_DECL((void));
extern void	PSUseShortHand ARGS_DECL((void));
#ifdef _PS_USE_EUC_FONT
extern void	PSUseEucFont ARGS_DECL((void));
#endif /* _PS_USE_EUC_FONT */

extern void	ResetPSInfo ARGS_DECL((void));
extern void	DoneResetPSInfo ARGS_DECL((void));

extern void	DumpPSMacro ARGS_DECL((FILE *));
extern int	ParsePsAdobeString ARGS_DECL((char *Str, int *UsePSAdobeStr,
		                              char *AdobeStr, char *EPSFStr));

extern void	CleanUpPS ARGS_DECL((void));
extern void	InitPS ARGS_DECL((void));

#ifdef _INCLUDE_FROM_PS_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_PS_C_*/

#endif /*_PS_E_*/
