/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-2000, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/tcp.e,v 4.6 2000/01/15 22:25:12 william Exp $
 */

#ifndef _TGIF_TCP_E_
#define _TGIF_TCP_E_

#ifdef _INCLUDE_FROM_TCP_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_TCP_C_*/

extern void	SetSocketBlockingState ARGS_DECL((int *pn_socket, int));
extern void	TcpFreeBuf ARGS_DECL((char *buf));
extern int	TcpDoConnect ARGS_DECL((char *psz_host, int us_port,
		                        int *pn_socket));
extern int	TcpDoWrite ARGS_DECL((int n_socket, char *buf, int buf_sz));
extern int	TcpDoRead ARGS_DECL((int n_socket, char **ppsz_buf,
		                     int *pn_buf_sz));

#ifdef _INCLUDE_FROM_TCP_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_TCP_C_*/

#endif /*_TGIF_TCP_E_*/
